/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.Plaza;
import com.rjconsultores.ventaboletos.service.PlazaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("editarPlazaController")
@Scope("prototype")
public class EditarPlazaController extends MyGenericForwardComposer {

    @Autowired
    private PlazaService plazaService;
    private Plaza plaza;
    private MyListbox plazaList;
    private Button btnApagar;
    private MyTextbox txtNome;
    private static Logger log = Logger.getLogger(EditarPlazaController.class);

    public Plaza getPlaza() {
        return plaza;
    }

    public void setPlaza(Plaza plaza) {
        this.plaza = plaza;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public MyTextbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(MyTextbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        plaza = (Plaza) Executions.getCurrent().getArg().get("plaza");
        plazaList = (MyListbox) Executions.getCurrent().getArg().get("plazaList");

        if (plaza.getPlazaId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getValue();

        try {
            plaza.setActivo(Boolean.TRUE);
            plaza.setFecmodif(Calendar.getInstance().getTime());
            plaza.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            List<Plaza> lsPlaza = plazaService.buscar(plaza.getNombplaza());

            if (!lsPlaza.isEmpty() && (!lsPlaza.get(0).equals(plaza))) {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarPlazaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {
                if (plaza.getPlazaId() == null) {
                    plazaService.suscribir(plaza);
                    plazaList.addItem(plaza);
                } else {
                    plazaService.actualizacion(plaza);
                    plazaList.updateItem(plaza);
                }

                Messagebox.show(
                        Labels.getLabel("editarPlazaController.MSG.suscribirOK"),
                        Labels.getLabel("editarPlazaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error("editarPlazaController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarPlazaController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPlazaController.MSG.borrarPergunta"),
                    Labels.getLabel("editarPlazaController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                plazaService.borrar(plaza);

                Messagebox.show(
                        Labels.getLabel("editarPlazaController.MSG.borrarOK"),
                        Labels.getLabel("editarPlazaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                plazaList.removeItem(plaza);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
